
#ifndef SCANSTRUCTS
#define SCANSTRUCTS

#define NSYMS 2027  /*size of symbols' hash table */
#define NRWDS  309  /*size of reserved words' hash table */
#define string_equal(a,b) (!strcmp(a,b))

typedef char *PSTRING;

PSTRING substring(PSTRING s, int i, int j );
PSTRING raise(PSTRING s1);
int string_eq(PSTRING s1, PSTRING s2);

struct symbols;
typedef struct symbols *PSYMBOLS;
struct symbols{
  PSTRING id;
  PSYMBOLS next;};

typedef struct symbols SYMBOLS;

SYMBOLS symtab[NSYMS];

extern int lineno ;
int yylineno ;

/* Added this temporary for character string reading.  Dec 29 94 MKS */
char yytemp[80];           

PSYMBOLS symlook();
PSYMBOLS seqsearch();
int  hash(); 

#endif SCANSTRUCTS



